package moe.oko.Kiafumi.command;

import moe.oko.Kiafumi.Kiafumi;
import moe.oko.Kiafumi.util.CommandInfo;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;
import net.dv8tion.jda.api.events.message.MessageReceivedEvent;

import java.awt.*;
import java.time.ZonedDateTime;
import java.util.ArrayList;
import java.util.List;

public class InviteCommand extends CommandClass{
    @Override
    public boolean isEnabled() {
        return true; //Always enabled
    }

    @Override
    public String getName() {
        return "Invite";
    }

    @Override
    public void legacyCommand(String[] args, MessageReceivedEvent e, boolean prefix) {

    }

    @Override
    public void newCommand(String name, SlashCommandInteractionEvent e) {
        if(e.getGuild() == null) { return; }
        switch (name) {
            case "invite":
                e.deferReply().queue();
                EmbedBuilder eb = new EmbedBuilder()
                        .setColor(Color.PINK)
                        .setFooter("Kiafumi - Maintained by oko.moe")
                        .setTimestamp(ZonedDateTime.now())
                        .setTitle("Invite me to your server!", Kiafumi.instance.config.assembleDefaultInvite())
                        .setDescription("Have a nice day!!!")
                        .setAuthor("oko.moe", "https://oko.moe", Kiafumi.JDA.getSelfUser().getAvatarUrl());
                e.getHook().sendMessageEmbeds(eb.build()).queue();
        }
    }

    @Override
    public List<String> getCommandsAsList() {
        return null;
    }

    @Override
    public List<CommandInfo> getSlashCommandInfo() {
        List<CommandInfo> cil = new ArrayList<>();
        CommandInfo ci = new CommandInfo("invite", "provides an invite for kiafumi.");
        cil.add(ci);
        return cil;
    }
}
